angular.module('starter.controllers', ['ionic'])


.controller('InfoCtrl', function($scope, $state, $ionicTabsDelegate) {
$scope.goForward = function () {
        var selected = $ionicTabsDelegate.selectedIndex();
        if (selected != -1) {
            $ionicTabsDelegate.select(selected + 1);
        }
    }

    $scope.goBack = function () {
        var selected = $ionicTabsDelegate.selectedIndex();
        if (selected != -1 && selected != 0) {
            $ionicTabsDelegate.select(selected - 1);
        }
    }
	
})

.controller('DetailCtrl', function($scope) {})

.controller('MyCtrl', function($scope, $ionicScrollDelegate) {})


.controller('ChestsCtrl', function($scope, $ionicPopup, $location, $ionicScrollDelegate, $ionicTabsDelegate, $ionicLoading, Chats) {
	
	//START : LODING SCREEN //
	$scope.showLoading = function() {
      $ionicLoading.show({
        template: '<p>Loading...</p><ion-spinner></ion-spinner>'
      });
   };

   $scope.hideLoading = function(){
      $ionicLoading.hide();
   };
	//END : LODING SCREEN //
  
  //START : TAB NAVIGATION //
  $scope.goForward = function () {
        var selected = $ionicTabsDelegate.selectedIndex();
        if (selected != -1) {
            $ionicTabsDelegate.select(selected + 1);
        }
    }

    $scope.goBack = function () {
        var selected = $ionicTabsDelegate.selectedIndex();
        if (selected != -1 && selected != 0) {
            $ionicTabsDelegate.select(selected - 1);
        }
    }
	//END : TAB NAVIGATION //

 //START : SCREEN SIZE //
  $scope.totalHeight = window.innerHeight;
  $scope.listCustomHeight = window.innerHeight/2.5;
  $scope.footerCustomHeight = $scope.totalHeight - $scope.listCustomHeight /2;
  //END : SCREEN SIZE //
  
  //alert($scope.totalHeight +" / "+$scope.listCustomHeight +" / "+$scope.footerCustomHeight);

  $scope.chats = Chats.all();
  
  var nextGolds = $scope.nextGolds = [{chest: window.localStorage.getItem("goldChestVal")}];
  var nextGiants = $scope.nextGiants = [{chest: window.localStorage.getItem("giantChestVal")}];
  var nextMagicals = $scope.nextMagicals = [{chest: window.localStorage.getItem("magicalChestVal")}];
  
  	$scope.saveData = function(chatId){
	  window.localStorage.setItem("data", chatId);
	  
	  var totalCountPerChest = 0;
	  var nextGoldChest = 0;
	  var nextGiantChest = 0;
	  var nextMagicalChest = 0;
	  
	  var isValidSearch = false;
	  var isGoldFound = false;
	  var isGiantFound = false;
	  var isMagicalFound = false;
	  
	  var endOfTheLoop = false;
	  
	  restartLoop:
	  while (true) {
	  for (var i = 0; i < $scope.chats.length; i++) {
		
        if ($scope.chats[i].id === parseInt(chatId) ) {
			isValidSearch = true;
			
			if(i== $scope.chats.length-1) { 
				endOfTheLoop = true;
				continue restartLoop;
			}
			continue;
        }
		
		if(isValidSearch){
			if($scope.chats[i].name == "Gold Chest" && !isGoldFound){
				nextGoldChest = $scope.chats[i].id - chatId;
				isGoldFound = true;
				
				if(endOfTheLoop){
					nextGoldChest = $scope.chats[i].id + (240-chatId)
				}	
			}
			
			if($scope.chats[i].name == "Giant Chest" && !isGiantFound){
				nextGiantChest = $scope.chats[i].id - chatId;
				isGiantFound = true;
				
				if(endOfTheLoop){
					nextGiantChest = $scope.chats[i].id + (240-chatId)
				}
			}
			
			if($scope.chats[i].name == "Magical Chest" && !isMagicalFound){
				
				nextMagicalChest = $scope.chats[i].id - chatId;
				isMagicalFound = true;
				
				if(endOfTheLoop){
					nextMagicalChest = $scope.chats[i].id + (240-chatId)
				}
			}
			
			if(isGoldFound && isGiantFound && isMagicalFound){
				break;
			}
			
			if(i== $scope.chats.length-1) { 
				endOfTheLoop = true;
				continue restartLoop;
			}
		}
      }
	  break;
	}
	  nextGolds.length = 0;
	  nextGolds.push({chest: nextGoldChest});
	  
	  nextGiants.length = 0;
	  nextGiants.push({chest: nextGiantChest});
	   
	  nextMagicals.length = 0;
	  nextMagicals.push({chest: nextMagicalChest});
	  
	  
	  //alert(" / "+ nextGoldChest+" / "+nextGiantChest+" / "+nextMagicalChest);
	  window.localStorage.setItem("goldChestVal", nextGoldChest);
	  window.localStorage.setItem("giantChestVal", nextGiantChest);
	  window.localStorage.setItem("magicalChestVal", nextMagicalChest);
	  
	   window.localStorage.setItem("scrollPositionChest", chatId);
	   
  }
  
   $scope.scrollMe = function() {  
	  $location.hash(window.localStorage.getItem("scrollPositionChest"));
	  $ionicScrollDelegate.anchorScroll();
           
    };
  
  $scope.loadData = function(){
	  return window.localStorage.getItem("data");
  }
});
